commit 135d178d088800992e3526fafb659788bb42ba34
Author: Robert Mader <robert.mader@posteo.de>
Date:   Thu Nov 21 23:00:53 2019 +0100

    Subject: [PATCH 1/6] cleanup: Use g_clear_signal_handler() where possible
    
    `g_clear_signal_handler()` is usually cleaner and saver than
    `g_signal_handler_disconnect()`. We use it new code, lets also
    adopt the existing one.
    
    See also https://gitlab.gnome.org/GNOME/mutter/merge_requests/868
    and https://gitlab.gnome.org/GNOME/mutter/merge_requests/940
    
    https://gitlab.gnome.org/GNOME/gnome-shell/merge_requests/842

diff --git a/src/calendar-server/calendar-sources.c b/src/calendar-server/calendar-sources.c
index ed76c015c..7e4c7f52e 100644
--- a/src/calendar-server/calendar-sources.c
+++ b/src/calendar-server/calendar-sources.c
@@ -112,7 +112,7 @@ static CalendarSources *calendar_sources_singleton = NULL;
 static void
 client_data_free (ClientData *data)
 {
-  g_signal_handler_disconnect (data->client, data->backend_died_id);
+  g_clear_signal_handler (&data->backend_died_id, data->client);
   g_object_unref (data->client);
   g_slice_free (ClientData, data);
 }
@@ -259,12 +259,12 @@ calendar_sources_finalize (GObject *object)
 
   if (sources->priv->registry)
     {
-      g_signal_handler_disconnect (sources->priv->registry,
-                                   sources->priv->source_added_id);
-      g_signal_handler_disconnect (sources->priv->registry,
-                                   sources->priv->source_changed_id);
-      g_signal_handler_disconnect (sources->priv->registry,
-                                   sources->priv->source_removed_id);
+      g_clear_signal_handler (&sources->priv->source_added_id,
+                              sources->priv->registry);
+      g_clear_signal_handler (&sources->priv->source_changed_id,
+                              sources->priv->registry);
+      g_clear_signal_handler (&sources->priv->source_removed_id,
+                              sources->priv->registry);
       g_object_unref (sources->priv->registry);
     }
   sources->priv->registry = NULL;
diff --git a/src/calendar-server/gnome-shell-calendar-server.c b/src/calendar-server/gnome-shell-calendar-server.c
index 9c88a2f9e..d04f0019c 100644
--- a/src/calendar-server/gnome-shell-calendar-server.c
+++ b/src/calendar-server/gnome-shell-calendar-server.c
@@ -789,8 +789,7 @@ app_free (App *app)
   g_hash_table_unref (app->appointments);
 
   g_object_unref (app->connection);
-  g_signal_handler_disconnect (app->sources,
-                               app->sources_signal_id);
+  g_clear_signal_handler (&app->sources_signal_id, app->sources);
   g_object_unref (app->sources);
 
   if (app->changed_timeout_id != 0)
